// Copyright 1986-2018 Xilinx, Inc. All Rights Reserved.
// --------------------------------------------------------------------------------
// Tool Version: Vivado v.2018.3 (win64) Build 2405991 Thu Dec  6 23:38:27 MST 2018
// Date        : Mon Feb  3 13:54:49 2020
// Host        : CB461-EE10461 running 64-bit major release  (build 9200)
// Command     : write_verilog -file C://Users//mbjerreg//verilog/unique_challenge.v -include_xilinx_libs
// Design      : top
// Purpose     : This is a Verilog netlist of the current design or from a specific cell of the design. The output is an
//               IEEE 1364-2001 compliant Verilog HDL file that contains netlist information obtained from the input
//               design files.
// Device      : xc7a100tcsg324-1
// --------------------------------------------------------------------------------
`timescale 1 ps / 1 ps

module a
   (zeta,
    epsilon);
  output zeta;
  input [17:0]epsilon;

  wire [2:0]a_temp;
  wire [17:0]epsilon;
  wire zeta;

  b b0
       (.delta(a_temp[0]),
        .gamma(epsilon[5:0]));
  b b1
       (.delta(a_temp[1]),
        .gamma(epsilon[11:6]));
  b b2
       (.delta(a_temp[2]),
        .gamma(epsilon[17:12]));
  LUT3 #(
    .INIT(8'h80)) 
    zeta_INST_0
       (.I0(a_temp[0]),
        .I1(a_temp[2]),
        .I2(a_temp[1]),
        .O(zeta));
endmodule

module b
   (delta,
    gamma);
  output delta;
  input [5:0]gamma;

  wire delta;
  wire [5:0]gamma;
  wire [2:0]temp;

  c c0
       (.alpha(gamma[1:0]),
        .beta(temp[0]));
  c c1
       (.alpha(gamma[3:2]),
        .beta(temp[1]));
  c c2
       (.alpha(gamma[5:4]),
        .beta(temp[2]));
  LUT3 #(
    .INIT(8'h80)) 
    delta_INST_0
       (.I0(temp[0]),
        .I1(temp[2]),
        .I2(temp[1]),
        .O(delta));
endmodule

module c
   (beta,
    alpha);
  output beta;
  input [1:0]alpha;

  wire [1:0]alpha;
  wire beta;

  LUT2 #(
    .INIT(4'h8)) 
    beta_INST_0
       (.I0(alpha[0]),
        .I1(alpha[1]),
        .O(beta));
endmodule

(* STRUCTURAL_NETLIST = "yes" *)
module top
   (theta,
    eta);
  output theta;
  input [53:0]eta;

  wire [53:0]eta;
  wire [53:0]eta_IBUF;
  wire theta;
  wire theta_OBUF;
  wire [2:0]top_temp;

  a a0
       (.epsilon(eta_IBUF[17:0]),
        .zeta(top_temp[0]));
  a a1
       (.epsilon(eta_IBUF[35:18]),
        .zeta(top_temp[1]));
  a a2
       (.epsilon(eta_IBUF[53:36]),
        .zeta(top_temp[2]));
  IBUF \eta_IBUF[0]_inst 
       (.I(eta[0]),
        .O(eta_IBUF[0]));
  IBUF \eta_IBUF[10]_inst 
       (.I(eta[10]),
        .O(eta_IBUF[10]));
  IBUF \eta_IBUF[11]_inst 
       (.I(eta[11]),
        .O(eta_IBUF[11]));
  IBUF \eta_IBUF[12]_inst 
       (.I(eta[12]),
        .O(eta_IBUF[12]));
  IBUF \eta_IBUF[13]_inst 
       (.I(eta[13]),
        .O(eta_IBUF[13]));
  IBUF \eta_IBUF[14]_inst 
       (.I(eta[14]),
        .O(eta_IBUF[14]));
  IBUF \eta_IBUF[15]_inst 
       (.I(eta[15]),
        .O(eta_IBUF[15]));
  IBUF \eta_IBUF[16]_inst 
       (.I(eta[16]),
        .O(eta_IBUF[16]));
  IBUF \eta_IBUF[17]_inst 
       (.I(eta[17]),
        .O(eta_IBUF[17]));
  IBUF \eta_IBUF[18]_inst 
       (.I(eta[18]),
        .O(eta_IBUF[18]));
  IBUF \eta_IBUF[19]_inst 
       (.I(eta[19]),
        .O(eta_IBUF[19]));
  IBUF \eta_IBUF[1]_inst 
       (.I(eta[1]),
        .O(eta_IBUF[1]));
  IBUF \eta_IBUF[20]_inst 
       (.I(eta[20]),
        .O(eta_IBUF[20]));
  IBUF \eta_IBUF[21]_inst 
       (.I(eta[21]),
        .O(eta_IBUF[21]));
  IBUF \eta_IBUF[22]_inst 
       (.I(eta[22]),
        .O(eta_IBUF[22]));
  IBUF \eta_IBUF[23]_inst 
       (.I(eta[23]),
        .O(eta_IBUF[23]));
  IBUF \eta_IBUF[24]_inst 
       (.I(eta[24]),
        .O(eta_IBUF[24]));
  IBUF \eta_IBUF[25]_inst 
       (.I(eta[25]),
        .O(eta_IBUF[25]));
  IBUF \eta_IBUF[26]_inst 
       (.I(eta[26]),
        .O(eta_IBUF[26]));
  IBUF \eta_IBUF[27]_inst 
       (.I(eta[27]),
        .O(eta_IBUF[27]));
  IBUF \eta_IBUF[28]_inst 
       (.I(eta[28]),
        .O(eta_IBUF[28]));
  IBUF \eta_IBUF[29]_inst 
       (.I(eta[29]),
        .O(eta_IBUF[29]));
  IBUF \eta_IBUF[2]_inst 
       (.I(eta[2]),
        .O(eta_IBUF[2]));
  IBUF \eta_IBUF[30]_inst 
       (.I(eta[30]),
        .O(eta_IBUF[30]));
  IBUF \eta_IBUF[31]_inst 
       (.I(eta[31]),
        .O(eta_IBUF[31]));
  IBUF \eta_IBUF[32]_inst 
       (.I(eta[32]),
        .O(eta_IBUF[32]));
  IBUF \eta_IBUF[33]_inst 
       (.I(eta[33]),
        .O(eta_IBUF[33]));
  IBUF \eta_IBUF[34]_inst 
       (.I(eta[34]),
        .O(eta_IBUF[34]));
  IBUF \eta_IBUF[35]_inst 
       (.I(eta[35]),
        .O(eta_IBUF[35]));
  IBUF \eta_IBUF[36]_inst 
       (.I(eta[36]),
        .O(eta_IBUF[36]));
  IBUF \eta_IBUF[37]_inst 
       (.I(eta[37]),
        .O(eta_IBUF[37]));
  IBUF \eta_IBUF[38]_inst 
       (.I(eta[38]),
        .O(eta_IBUF[38]));
  IBUF \eta_IBUF[39]_inst 
       (.I(eta[39]),
        .O(eta_IBUF[39]));
  IBUF \eta_IBUF[3]_inst 
       (.I(eta[3]),
        .O(eta_IBUF[3]));
  IBUF \eta_IBUF[40]_inst 
       (.I(eta[40]),
        .O(eta_IBUF[40]));
  IBUF \eta_IBUF[41]_inst 
       (.I(eta[41]),
        .O(eta_IBUF[41]));
  IBUF \eta_IBUF[42]_inst 
       (.I(eta[42]),
        .O(eta_IBUF[42]));
  IBUF \eta_IBUF[43]_inst 
       (.I(eta[43]),
        .O(eta_IBUF[43]));
  IBUF \eta_IBUF[44]_inst 
       (.I(eta[44]),
        .O(eta_IBUF[44]));
  IBUF \eta_IBUF[45]_inst 
       (.I(eta[45]),
        .O(eta_IBUF[45]));
  IBUF \eta_IBUF[46]_inst 
       (.I(eta[46]),
        .O(eta_IBUF[46]));
  IBUF \eta_IBUF[47]_inst 
       (.I(eta[47]),
        .O(eta_IBUF[47]));
  IBUF \eta_IBUF[48]_inst 
       (.I(eta[48]),
        .O(eta_IBUF[48]));
  IBUF \eta_IBUF[49]_inst 
       (.I(eta[49]),
        .O(eta_IBUF[49]));
  IBUF \eta_IBUF[4]_inst 
       (.I(eta[4]),
        .O(eta_IBUF[4]));
  IBUF \eta_IBUF[50]_inst 
       (.I(eta[50]),
        .O(eta_IBUF[50]));
  IBUF \eta_IBUF[51]_inst 
       (.I(eta[51]),
        .O(eta_IBUF[51]));
  IBUF \eta_IBUF[52]_inst 
       (.I(eta[52]),
        .O(eta_IBUF[52]));
  IBUF \eta_IBUF[53]_inst 
       (.I(eta[53]),
        .O(eta_IBUF[53]));
  IBUF \eta_IBUF[5]_inst 
       (.I(eta[5]),
        .O(eta_IBUF[5]));
  IBUF \eta_IBUF[6]_inst 
       (.I(eta[6]),
        .O(eta_IBUF[6]));
  IBUF \eta_IBUF[7]_inst 
       (.I(eta[7]),
        .O(eta_IBUF[7]));
  IBUF \eta_IBUF[8]_inst 
       (.I(eta[8]),
        .O(eta_IBUF[8]));
  IBUF \eta_IBUF[9]_inst 
       (.I(eta[9]),
        .O(eta_IBUF[9]));
  OBUF theta_OBUF_inst
       (.I(theta_OBUF),
        .O(theta));
  LUT3 #(
    .INIT(8'h80)) 
    theta_OBUF_inst_i_1
       (.I0(top_temp[0]),
        .I1(top_temp[2]),
        .I2(top_temp[1]),
        .O(theta_OBUF));
endmodule
///////////////////////////////////////////////////////////////////////////////
// Copyright (c) 1995/2016 Xilinx, Inc.
// All Right Reserved.
///////////////////////////////////////////////////////////////////////////////
//   ____  ____
//  /   /\/   /
// /___/  \  /    Vendor      : Xilinx
// \   \   \/     Version     : 2017.1
//  \   \         Description : Xilinx Unified Simulation Library Component
//  /   /                  3-Bit Look-Up Table
// /___/   /\     Filename : LUT3.v
// \   \  /  \
//  \___\/\___\
//
///////////////////////////////////////////////////////////////////////////////
//  Revision:
//    03/23/04 - Initial version.
//    03/11/05 - Add LOC Parameter
//    12/13/11 - 524859 - Added `celldefine and `endcelldefine
//    09/12/16 - ANSI ports, speed improvements
//  End Revision:
///////////////////////////////////////////////////////////////////////////////

`timescale 1 ps/1 ps

`celldefine

module LUT3 #(
`ifdef XIL_TIMING
  parameter LOC = "UNPLACED",
`endif
  parameter [7:0] INIT = 8'h00
)(
  output O,

  input I0,
  input I1,
  input I2
);

// define constants
  localparam MODULE_NAME = "LUT3";

  reg trig_attr = 1'b0;
// include dynamic registers - XILINX test only
`ifdef XIL_DR
  `include "LUT3_dr.v"
`else
  reg [7:0] INIT_REG = INIT;
`endif

  x_lut3_mux8 (O, INIT_REG[7], INIT_REG[6], INIT_REG[5], INIT_REG[4], INIT_REG[3], INIT_REG[2], INIT_REG[1], INIT_REG[0], I2, I1, I0);

`ifdef XIL_TIMING
  specify
	(I0 => O) = (0:0:0, 0:0:0);
	(I1 => O) = (0:0:0, 0:0:0);
	(I2 => O) = (0:0:0, 0:0:0);
	specparam PATHPULSE$ = 0;
  endspecify
`endif

endmodule

`endcelldefine

primitive x_lut3_mux8 (o, d7, d6, d5, d4, d3, d2, d1, d0, s2, s1, s0);

  output o;
  input d7, d6, d5, d4, d3, d2, d1, d0;
  input s2, s1, s0;

  table

    // d7  d6  d5  d4  d3  d2  d1  d0  s2  s1  s0 : o;

       ?   ?   ?   ?   ?   ?   ?   1   0   0   0  : 1;
       ?   ?   ?   ?   ?   ?   ?   0   0   0   0  : 0;
       ?   ?   ?   ?   ?   ?   1   ?   0   0   1  : 1;
       ?   ?   ?   ?   ?   ?   0   ?   0   0   1  : 0;
       ?   ?   ?   ?   ?   1   ?   ?   0   1   0  : 1;
       ?   ?   ?   ?   ?   0   ?   ?   0   1   0  : 0;
       ?   ?   ?   ?   1   ?   ?   ?   0   1   1  : 1;
       ?   ?   ?   ?   0   ?   ?   ?   0   1   1  : 0;
       ?   ?   ?   1   ?   ?   ?   ?   1   0   0  : 1;
       ?   ?   ?   0   ?   ?   ?   ?   1   0   0  : 0;
       ?   ?   1   ?   ?   ?   ?   ?   1   0   1  : 1;
       ?   ?   0   ?   ?   ?   ?   ?   1   0   1  : 0;
       ?   1   ?   ?   ?   ?   ?   ?   1   1   0  : 1;
       ?   0   ?   ?   ?   ?   ?   ?   1   1   0  : 0;
       1   ?   ?   ?   ?   ?   ?   ?   1   1   1  : 1;
       0   ?   ?   ?   ?   ?   ?   ?   1   1   1  : 0;

       ?   ?   ?   ?   ?   ?   0   0   0   0   x  : 0;
       ?   ?   ?   ?   ?   ?   1   1   0   0   x  : 1;
       ?   ?   ?   ?   0   0   ?   ?   0   1   x  : 0;
       ?   ?   ?   ?   1   1   ?   ?   0   1   x  : 1;
       ?   ?   0   0   ?   ?   ?   ?   1   0   x  : 0;
       ?   ?   1   1   ?   ?   ?   ?   1   0   x  : 1;
       0   0   ?   ?   ?   ?   ?   ?   1   1   x  : 0;
       1   1   ?   ?   ?   ?   ?   ?   1   1   x  : 1;

       ?   ?   ?   ?   ?   0   ?   0   0   x   0  : 0;
       ?   ?   ?   ?   ?   1   ?   1   0   x   0  : 1;
       ?   ?   ?   ?   0   ?   0   ?   0   x   1  : 0;
       ?   ?   ?   ?   1   ?   1   ?   0   x   1  : 1;
       ?   0   ?   0   ?   ?   ?   ?   1   x   0  : 0;
       ?   1   ?   1   ?   ?   ?   ?   1   x   0  : 1;
       0   ?   0   ?   ?   ?   ?   ?   1   x   1  : 0;
       1   ?   1   ?   ?   ?   ?   ?   1   x   1  : 1;

       ?   ?   ?   0   ?   ?   ?   0   x   0   0  : 0;
       ?   ?   ?   1   ?   ?   ?   1   x   0   0  : 1;
       ?   ?   0   ?   ?   ?   0   ?   x   0   1  : 0;
       ?   ?   1   ?   ?   ?   1   ?   x   0   1  : 1;
       ?   0   ?   ?   ?   0   ?   ?   x   1   0  : 0;
       ?   1   ?   ?   ?   1   ?   ?   x   1   0  : 1;
       0   ?   ?   ?   0   ?   ?   ?   x   1   1  : 0;
       1   ?   ?   ?   1   ?   ?   ?   x   1   1  : 1;

       ?   ?   ?   ?   0   0   0   0   0   x   x  : 0;
       ?   ?   ?   ?   1   1   1   1   0   x   x  : 1;
       0   0   0   0   ?   ?   ?   ?   1   x   x  : 0;
       1   1   1   1   ?   ?   ?   ?   1   x   x  : 1;

       ?   ?   0   0   ?   ?   0   0   x   0   x  : 0;
       ?   ?   1   1   ?   ?   1   1   x   0   x  : 1;
       0   0   ?   ?   0   0   ?   ?   x   1   x  : 0;
       1   1   ?   ?   1   1   ?   ?   x   1   x  : 1;

       ?   0   ?   0   ?   0   ?   0   x   x   0  : 0;
       ?   1   ?   1   ?   1   ?   1   x   x   0  : 1;
       0   ?   0   ?   0   ?   0   ?   x   x   1  : 0;
       1   ?   1   ?   1   ?   1   ?   x   x   1  : 1;

       0   0   0   0   0   0   0   0   x   x   x  : 0;
       1   1   1   1   1   1   1   1   x   x   x  : 1;

  endtable

endprimitive

///////////////////////////////////////////////////////////////////////////////
// Copyright (c) 1995/2004 Xilinx, Inc.
// All Right Reserved.
///////////////////////////////////////////////////////////////////////////////
//   ____  ____
//  /   /\/   /
// /___/  \  /    Vendor : Xilinx
// \   \   \/     Version : 10.1
//  \   \         Description : Xilinx Functional Simulation Library Component
//  /   /                  Output Buffer
// /___/   /\     Filename : OBUF.v
// \   \  /  \    Timestamp : Thu Mar 25 16:42:59 PST 2004
//  \___\/\___\
//
// Revision:
//    03/23/04 - Initial version.
//    02/22/06 - CR#226003 - Added integer, real parameter type
//    05/23/07 - Changed timescale to 1 ps / 1 ps.

`timescale  1 ps / 1 ps


`celldefine

module OBUF (O, I);

    parameter CAPACITANCE = "DONT_CARE";
    parameter integer DRIVE = 12;
    parameter IOSTANDARD = "DEFAULT";

`ifdef XIL_TIMING

    parameter LOC = " UNPLACED";

`endif

    parameter SLEW = "SLOW";
   
    output O;

    input  I;

    tri0 GTS = glbl.GTS;

    bufif0 B1 (O, I, GTS);

    initial begin
	
        case (CAPACITANCE)

            "LOW", "NORMAL", "DONT_CARE" : ;
            default : begin
                          $display("Attribute Syntax Error : The attribute CAPACITANCE on OBUF instance %m is set to %s.  Legal values for this attribute are DONT_CARE, LOW or NORMAL.", CAPACITANCE);
                          #1 $finish;
                      end

        endcase

    end

    
`ifdef XIL_TIMING
    
    specify
        (I => O) = (0:0:0, 0:0:0);
        specparam PATHPULSE$ = 0;
    endspecify

`endif

    
endmodule

`endcelldefine





///////////////////////////////////////////////////////////////////////////////
// Copyright (c) 1995/2016 Xilinx, Inc.
// All Right Reserved.
///////////////////////////////////////////////////////////////////////////////
//   ____  ____
//  /   /\/   /
// /___/  \  /    Vendor      : Xilinx
// \   \   \/     Version     : 2017.1
//  \   \         Description : Xilinx Unified Simulation Library Component
//  /   /                  2-Bit Look-Up Table
// /___/   /\     Filename : LUT2.v
// \   \  /  \
//  \___\/\___\
//
///////////////////////////////////////////////////////////////////////////////
//  Revision:
//    03/23/04 - Initial version.
//    03/11/05 - Add LOC Parameter
//    12/13/11 - 524859 - Added `celldefine and `endcelldefine
//    09/12/16 - ANSI ports, speed improvements
//  End Revision:
///////////////////////////////////////////////////////////////////////////////

`timescale 1 ps/1 ps

`celldefine

module LUT2 #(
`ifdef XIL_TIMING
  parameter LOC = "UNPLACED",
`endif
  parameter [3:0] INIT = 4'h0
)(
  output O,

  input I0,
  input I1
);

// define constants
  localparam MODULE_NAME = "LUT2";

  reg trig_attr = 1'b0;
// include dynamic registers - XILINX test only
`ifdef XIL_DR
  `include "LUT2_dr.v"
`else
  reg [3:0] INIT_REG = INIT;
`endif

  x_lut2_mux4 (O, INIT_REG[3], INIT_REG[2], INIT_REG[1], INIT_REG[0], I1, I0);

`ifdef XIL_TIMING
  specify
	(I0 => O) = (0:0:0, 0:0:0);
	(I1 => O) = (0:0:0, 0:0:0);
	specparam PATHPULSE$ = 0;
  endspecify
`endif

endmodule

`endcelldefine

primitive x_lut2_mux4 (o, d3, d2, d1, d0, s1, s0);

  output o;
  input d3, d2, d1, d0;
  input s1, s0;

  table

    // d3  d2  d1  d0  s1  s0 : o;

       ?   ?   ?   1   0   0  : 1;
       ?   ?   ?   0   0   0  : 0;
       ?   ?   1   ?   0   1  : 1;
       ?   ?   0   ?   0   1  : 0;
       ?   1   ?   ?   1   0  : 1;
       ?   0   ?   ?   1   0  : 0;
       1   ?   ?   ?   1   1  : 1;
       0   ?   ?   ?   1   1  : 0;

       ?   ?   0   0   0   x  : 0;
       ?   ?   1   1   0   x  : 1;
       0   0   ?   ?   1   x  : 0;
       1   1   ?   ?   1   x  : 1;

       ?   0   ?   0   x   0  : 0;
       ?   1   ?   1   x   0  : 1;
       0   ?   0   ?   x   1  : 0;
       1   ?   1   ?   x   1  : 1;

       0   0   0   0   x   x  : 0;
       1   1   1   1   x   x  : 1;

  endtable

endprimitive

///////////////////////////////////////////////////////////////////////////////
// Copyright (c) 1995/2004 Xilinx, Inc.
// All Right Reserved.
///////////////////////////////////////////////////////////////////////////////
//   ____  ____
//  /   /\/   /
// /___/  \  /    Vendor : Xilinx
// \   \   \/     Version : 10.1
//  \   \         Description : Xilinx Functional Simulation Library Component
//  /   /                  Input Buffer
// /___/   /\     Filename : IBUF.v
// \   \  /  \    Timestamp : Thu Mar 25 16:42:23 PST 2004
//  \___\/\___\
//
// Revision:
//    03/23/04 - Initial version.
//    05/23/07 - Changed timescale to 1 ps / 1 ps.
//    07/16/08 - Added IBUF_LOW_PWR attribute.
//    04/22/09 - CR 519127 - Changed IBUF_LOW_PWR default to TRUE.
//    12/13/11 - Added `celldefine and `endcelldefine (CR 524859).
//    10/22/14 - Added #1 to $finish (CR 808642).
// End Revision

`timescale  1 ps / 1 ps


`celldefine

module IBUF (O, I);

    parameter CAPACITANCE = "DONT_CARE";
    parameter IBUF_DELAY_VALUE = "0";
    parameter IBUF_LOW_PWR = "TRUE";
    parameter IFD_DELAY_VALUE = "AUTO";
    parameter IOSTANDARD = "DEFAULT";

`ifdef XIL_TIMING

    parameter LOC = " UNPLACED";

`endif

    
    output O;
    input  I;

    buf B1 (O, I);
    
    
    initial begin
	
        case (CAPACITANCE)

            "LOW", "NORMAL", "DONT_CARE" : ;
            default : begin
                          $display("Attribute Syntax Error : The attribute CAPACITANCE on IBUF instance %m is set to %s.  Legal values for this attribute are DONT_CARE, LOW or NORMAL.", CAPACITANCE);
                          #1 $finish;
                      end

        endcase


	case (IBUF_DELAY_VALUE)

            "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16" : ;
            default : begin
                          $display("Attribute Syntax Error : The attribute IBUF_DELAY_VALUE on IBUF instance %m is set to %s.  Legal values for this attribute are 0, 1, 2, ... or 16.", IBUF_DELAY_VALUE);
                          #1 $finish;
                      end

        endcase

        case (IBUF_LOW_PWR)

            "FALSE", "TRUE" : ;
            default : begin
                          $display("Attribute Syntax Error : The attribute IBUF_LOW_PWR on IBUF instance %m is set to %s.  Legal values for this attribute are TRUE or FALSE.", IBUF_LOW_PWR);
                          #1 $finish;
                      end

        endcase


	case (IFD_DELAY_VALUE)

            "AUTO", "0", "1", "2", "3", "4", "5", "6", "7", "8" : ;
            default : begin
                          $display("Attribute Syntax Error : The attribute IFD_DELAY_VALUE on IBUF instance %m is set to %s.  Legal values for this attribute are AUTO, 0, 1, 2, ... or 8.", IFD_DELAY_VALUE);
                          #1 $finish;
                      end

	endcase
	
    end


`ifdef XIL_TIMING
    
    specify
        (I => O) = (0:0:0, 0:0:0);
        specparam PATHPULSE$ = 0;
    endspecify
    
`endif

    
endmodule

`endcelldefine


